#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "mypopen.h"
#include <gst/gst.h>

static GtkWidget *configureWindow;

gboolean
on_gmencoderWindow_delete_event      (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gtk_main_quit();

	return TRUE;
}


gboolean
on_fileList_clist_drag_motion          (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_fileList_clist_drag_begin           (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data)
{

}


void
on_fileList_clist_drag_end             (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data)
{

}


void
on_fileList_clist_drag_data_get        (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data)
{

}


void
on_fileList_clist_drag_data_received   (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data)
{

}


void
on_fileList_clist_drag_data_delete     (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gpointer         user_data)
{

}

/* 인코딩할 파일 열기 */
void
on_fileAdd_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *fs;
	GtkTreeIter iter;
	gboolean already = FALSE;
	GtkWidget *messagebox;
	gboolean valid;

	fs = create_openfile_dialog();

	if (gtk_dialog_run(GTK_DIALOG(fs)) == GTK_RESPONSE_ACCEPT) {
		char *f1, *f2;
		
		f1 = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(fs));
		
		valid = gtk_tree_model_get_iter_first(GTK_TREE_MODEL(user_data), &iter);
		
		while (valid) {
			gtk_tree_model_get(GTK_TREE_MODEL(user_data), &iter, COL_FILENAME, &f2, -1);

			if (!strcmp(f1, f2)) {
				already = TRUE;
				
				gtk_widget_show(create_gmencoder_messagebox("파일이 이미 포함되어 있습니다."));
				break;
			}
			
			valid = gtk_tree_model_iter_next(GTK_TREE_MODEL(user_data), &iter);
		}

		if (already == FALSE)
			get_video_info(f1, user_data);
		
		file_num++;
		
		g_free(f1);
	}
	
	gtk_widget_destroy(fs);
}


void
on_fileDel_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkTreeSelection *selection;
	GtkTreeModel *model;
	GtkTreeIter iter;
	
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(user_data));
	
	if (gtk_tree_selection_get_selected(selection, &model, &iter)) {
		gtk_list_store_remove(GTK_LIST_STORE(model), &iter);
		file_num--;
	}
}


void
on_fileAllDel_button_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_list_store_clear(GTK_LIST_STORE(user_data));
	
	file_num = 0;
}

void on_workStart_button_clicked (GtkButton *button, gpointer user_data)
{
	gboolean valid;
	GtkTreeIter iter;
	int result;

	if (!(gtk_tree_model_get_iter_first(GTK_TREE_MODEL(user_data), &iter))) {
		gtk_widget_show(create_gmencoder_messagebox("작업 파일이 없습니다."));
	} else {
		thr_id = pthread_create(&mencoder_pthread, NULL, play_mencoder, (gpointer)user_data);
		pthread_detach(mencoder_pthread);
		
		workState_dialog = create_workingState_dialog();

		result = gtk_dialog_run(GTK_DIALOG(workState_dialog));
		if ((result == GTK_RESPONSE_CANCEL) || (result == GTK_RESPONSE_DELETE_EVENT)) {
			pthread_cancel(mencoder_pthread);
		}
	}
}


void
on_targetDir_filechooserbutton_selection_changed
                                        (GtkFileChooser  *filechooser,
                                        gpointer         user_data)
{
	free(work_info.outDir);
	work_info.outDir = gtk_file_chooser_get_filename(filechooser);
}


void
on_configure_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
	configureWindow = create_configure_window();
	gtk_widget_show(configureWindow);
}


void
on_loadConfigure_button_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *lc;
	GtkListStore *store;
	GtkTreeSelection *selection;
	GtkTreeIter iter;
	GtkTreeModel *model;
	gchar *name;
	
	lc = create_configSelection_window();

	if (gtk_dialog_run(GTK_DIALOG(lc)) == GTK_RESPONSE_OK) {
		store = g_object_get_data(G_OBJECT(lc), "miri_store");
		selection = g_object_get_data(G_OBJECT(lc), "miri_select");
		
		gtk_tree_selection_get_selected(selection, &model, &iter);
		gtk_tree_model_get(model, &iter, COL_MIRI, &name, -1);
		puts(name);
		g_free(name);
	}

	gtk_widget_destroy(lc);
}


void
on_listenSound_check_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_playsound_filechooserbutton_selection_changed
                                        (GtkFileChooser  *filechooser,
                                        gpointer         user_data)
{
	gst_element_set_state(GST_ELEMENT(gstSound), GST_STATE_READY);
}


void
on_playsound_filechooserbutton_update_preview
                                        (GtkFileChooser  *filechooser,
                                        gpointer         user_data)
{
	gchar *fn, *uri;

	fn = gtk_file_chooser_get_preview_filename(filechooser);

	if (fn) {
		uri = g_filename_to_uri(fn, NULL, NULL);
		gst_element_set_state(GST_ELEMENT(gstSound), GST_STATE_READY);
		g_object_set(G_OBJECT(gstSound), "uri", uri, NULL);
		gst_element_set_state(gstSound, GST_STATE_PLAYING);
		g_free(uri);
		g_free(fn);
	}
}

void
on_about_button_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_show(create_gmencoderAbout_window());
}


void
on_quit_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	on_gmencoderWindow_delete_event(NULL, NULL, NULL);

}


gboolean
on_configure_window_destroy_event      (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
}

void on_vbitrate_comboboxentry_changed(GtkComboBox *combobox, gpointer user_data)
{
	config.vbitrate =  gtk_combo_box_get_active(combobox);
}


void
on_frameChange_checkbutton_toggled     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	config.use_ofps = gtk_toggle_button_get_active(togglebutton);
	
	gtk_widget_set_sensitive(frameChange_comboboxentry, config.use_ofps);
}


void
on_scaleChange_checkbutton_toggled     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	config.use_scale = gtk_toggle_button_get_active(togglebutton);

	gtk_widget_set_sensitive(hScale_spinbutton, config.use_scale);
	gtk_widget_set_sensitive(vScale_spinbutton, config.use_scale);
	gtk_widget_set_sensitive(scaleMenu, config.use_scale);
}


void
on_crop_checkbutton_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	config.use_crop = gtk_toggle_button_get_active(togglebutton);

	gtk_widget_set_sensitive(crop_comboboxentry, config.use_crop);
}

void on_crop_comboboxentry_changed(GtkComboBox *combobox, gpointer user_data)
{
	config.crop = gtk_combo_box_get_active(combobox);
}

void
on_hScale_spinbutton_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{
	config.hscale = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(editable));
}


void
on_vScale_spinbutton_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{
	config.vscale = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(editable));
}

void
on_vcodec_comboboxentry_changed       (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	config.vcodec = gtk_combo_box_get_active(combobox);
}


void
on_addBlackarea_checkbutton_toggled    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_fullScreen_checkbutton_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_srate_checkbutton_toggled     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	config.use_srate = gtk_toggle_button_get_active(togglebutton);
	gtk_widget_set_sensitive(srate_comboboxentry, config.use_srate);
}


void
on_acodec_comboboxentry_changed    (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	config.acodec = gtk_combo_box_get_active(combobox);
}


void
on_comboboxentry6_changed              (GtkComboBox     *combobox,
                                        gpointer         user_data)
{

}


void
on_volumn_comboboxentry_changed        (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	config.vol = gtk_combo_box_get_active(combobox);
}


void
on_audioQuality_comboboxentry_changed
                                        (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	config.aq = gtk_combo_box_get_active(combobox);
}


void
on_comboboxentry_changed               (GtkComboBox     *combobox,
                                        gpointer         user_data)
{

}


void
on_vbr_comboboxentry_changed           (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	config.vbr = gtk_combo_box_get_active(combobox);
}


void
on_srate_comboboxentry_changed   (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	config.srate = gtk_combo_box_get_active(combobox);
}


void
on_useSource_checkbutton_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	config.useSource = gtk_toggle_button_get_active(togglebutton);
	
	if (config.useSource == TRUE) {
		gtk_widget_set_sensitive(vbitrate_comboboxentry, FALSE);
		gtk_widget_set_sensitive(frameChange_checkbutton, FALSE);
		gtk_widget_set_sensitive(frameChange_comboboxentry, FALSE);
		gtk_widget_set_sensitive(scaleChange_checkbutton, FALSE);
		gtk_widget_set_sensitive(hScale_spinbutton, FALSE);
		gtk_widget_set_sensitive(vScale_spinbutton, FALSE);
		gtk_widget_set_sensitive(scaleMenu, FALSE);
		gtk_widget_set_sensitive(vcodec_comboboxentry, FALSE);
		
		gtk_widget_set_sensitive(subpos_comboboxentry, FALSE);
		gtk_widget_set_sensitive(subblur_comboboxentry, FALSE);
		gtk_widget_set_sensitive(subOutline_comboboxentry, FALSE);
		gtk_widget_set_sensitive(font_entry, FALSE);
		gtk_widget_set_sensitive(font_button, FALSE);
		gtk_widget_set_sensitive(subsize_comboboxentry, FALSE);
		
		gtk_widget_set_sensitive(sub_checkbutton, FALSE);
	} else {
		gtk_widget_set_sensitive(vbitrate_comboboxentry, TRUE);
		gtk_widget_set_sensitive(frameChange_checkbutton, TRUE);
		gtk_widget_set_sensitive(frameChange_comboboxentry, config.use_ofps);
		gtk_widget_set_sensitive(scaleChange_checkbutton, TRUE);
		gtk_widget_set_sensitive(hScale_spinbutton, config.use_scale);
		gtk_widget_set_sensitive(vScale_spinbutton, config.use_scale);
		gtk_widget_set_sensitive(scaleMenu, config.use_scale);
		gtk_widget_set_sensitive(vcodec_comboboxentry, TRUE);
		
		gtk_widget_set_sensitive(subpos_comboboxentry, TRUE);
		gtk_widget_set_sensitive(subblur_comboboxentry, TRUE);
		gtk_widget_set_sensitive(subOutline_comboboxentry, TRUE);
		gtk_widget_set_sensitive(font_entry, TRUE);
		gtk_widget_set_sensitive(font_button, TRUE);
		gtk_widget_set_sensitive(subsize_comboboxentry, TRUE);
		
		gtk_widget_set_sensitive(sub_checkbutton, TRUE);
	}
}


void
on_sub_checkbutton_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	config.use_sub = gtk_toggle_button_get_active(togglebutton);
}


void
on_useSourceSound_checkbutton_toggled  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	config.useSSound = gtk_toggle_button_get_active(togglebutton);

	if (config.useSSound == TRUE) {
		gtk_widget_set_sensitive(acodec_comboboxentry, FALSE);
		gtk_widget_set_sensitive(abitrate_comboboxentry, FALSE);
		gtk_widget_set_sensitive(volumn_comboboxentry, FALSE);
		gtk_widget_set_sensitive(audioQuality_comboboxentry, FALSE);
		gtk_widget_set_sensitive(amode_comboboxentry, FALSE);
		gtk_widget_set_sensitive(vbr_comboboxentry, FALSE);
		gtk_widget_set_sensitive(srate_checkbutton, FALSE);
		gtk_widget_set_sensitive(srate_comboboxentry, FALSE);
	} else {
		gtk_widget_set_sensitive(acodec_comboboxentry, TRUE);
		gtk_widget_set_sensitive(abitrate_comboboxentry, TRUE);
		gtk_widget_set_sensitive(volumn_comboboxentry, TRUE);
		gtk_widget_set_sensitive(audioQuality_comboboxentry, TRUE);
		gtk_widget_set_sensitive(amode_comboboxentry, TRUE);
		gtk_widget_set_sensitive(vbr_comboboxentry, TRUE);
		gtk_widget_set_sensitive(srate_checkbutton, TRUE);
		gtk_widget_set_sensitive(srate_comboboxentry, config.use_srate);
	}
}


void
on_indexRebuild_checkbutton_toggled    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	config.onlyrebuild = gtk_toggle_button_get_active(togglebutton);
	
	if (config.onlyrebuild == TRUE) {
		gtk_widget_set_sensitive(vbitrate_comboboxentry, FALSE);
		gtk_widget_set_sensitive(frameChange_checkbutton, FALSE);
		gtk_widget_set_sensitive(frameChange_comboboxentry, FALSE);
		gtk_widget_set_sensitive(scaleChange_checkbutton, FALSE);
		gtk_widget_set_sensitive(hScale_spinbutton, FALSE);
		gtk_widget_set_sensitive(vScale_spinbutton, FALSE);
		gtk_widget_set_sensitive(scaleMenu, FALSE);
		gtk_widget_set_sensitive(vcodec_comboboxentry, FALSE);
		
		gtk_widget_set_sensitive(acodec_comboboxentry, FALSE);
		gtk_widget_set_sensitive(abitrate_comboboxentry, FALSE);
		gtk_widget_set_sensitive(volumn_comboboxentry, FALSE);
		gtk_widget_set_sensitive(audioQuality_comboboxentry, FALSE);
		gtk_widget_set_sensitive(amode_comboboxentry, FALSE);
		gtk_widget_set_sensitive(vbr_comboboxentry, FALSE);
		gtk_widget_set_sensitive(srate_checkbutton, FALSE);
		gtk_widget_set_sensitive(srate_comboboxentry, FALSE);
		
		gtk_widget_set_sensitive(subpos_comboboxentry, FALSE);
		gtk_widget_set_sensitive(subblur_comboboxentry, FALSE);
		gtk_widget_set_sensitive(subOutline_comboboxentry, FALSE);
		gtk_widget_set_sensitive(font_entry, FALSE);
		gtk_widget_set_sensitive(font_button, FALSE);
		gtk_widget_set_sensitive(subsize_comboboxentry, FALSE);
		
		gtk_widget_set_sensitive(useSource_checkbutton, FALSE);
		gtk_widget_set_sensitive(sub_checkbutton, FALSE);
		gtk_widget_set_sensitive(useSourceSound_checkbutton, FALSE);
	} else {
		on_useSource_checkbutton_toggled((gpointer)useSource_checkbutton, NULL);
		on_useSourceSound_checkbutton_toggled((gpointer)useSourceSound_checkbutton, NULL);
		
		gtk_widget_set_sensitive(useSource_checkbutton, TRUE);
		gtk_widget_set_sensitive(useSourceSound_checkbutton, TRUE);
	}
}


void
on_callBasicSetting_button_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
	config_Init();
	
	gtk_widget_destroy(configureWindow);
	
	configureWindow = create_configure_window();
	
	gtk_widget_show(configureWindow);
}


void
on_configSelection2_button_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{

}


void on_font_button_selection_changed(	GtkFileChooser	*filechooser,
										gpointer		user_data)
{
	strcpy(config.subfont, gtk_file_chooser_get_filename(filechooser));

	gtk_entry_set_text(GTK_ENTRY(user_data), config.subfont);
	g_printf("%s\n", config.subfont);
}


void
on_configSave_button_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *miri;
	GtkWidget *name;
	GtkWidget *explain;
	char *buf;
	FILE *fp;
	
	miri = create_miriSave_dialog();
	
	if (gtk_dialog_run(GTK_DIALOG(miri)) == GTK_RESPONSE_OK) {
		name = g_object_get_data(G_OBJECT(miri), "name_entry");
		explain = g_object_get_data(G_OBJECT(miri), "explain_entry");
		
		fp = fopen(miri_file, "a+");
		
		buf = strdup(gtk_entry_get_text(GTK_ENTRY(name)));
		fprintf(fp, "[%s]\n", buf);
		free(buf);
		buf = strdup(gtk_entry_get_text(GTK_ENTRY(explain)));
		fprintf(fp, "%s\n", buf);
		free(buf);
		
		save_configure(fp);
		
		fclose(fp);
	}
	
	gtk_widget_destroy(miri);
}


void
on_s220_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(hScale_spinbutton), (gdouble)220);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(vScale_spinbutton), (gdouble)176);
	config.hscale = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(hScale_spinbutton));
	config.vscale = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(vScale_spinbutton));
}


void
on_s240_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(hScale_spinbutton), (gdouble)240);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(vScale_spinbutton), (gdouble)180);
	config.hscale = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(hScale_spinbutton));
	config.vscale = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(vScale_spinbutton));
}


void
on_s320_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(hScale_spinbutton), (gdouble)320);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(vScale_spinbutton), (gdouble)240);
	config.hscale = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(hScale_spinbutton));
	config.vscale = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(vScale_spinbutton));
}


void
on_s480_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(hScale_spinbutton), (gdouble)480);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(vScale_spinbutton), (gdouble)272);
	config.hscale = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(hScale_spinbutton));
	config.vscale = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(vScale_spinbutton));
}


void
on_s640_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(hScale_spinbutton), (gdouble)640);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(vScale_spinbutton), (gdouble)480);
	config.hscale = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(hScale_spinbutton));
	config.vscale = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(vScale_spinbutton));
}


void
on_frameChange_comboboxentry_changed   (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	config.ofps = gtk_combo_box_get_active(combobox);
}


void
on_abitrate_comboboxentry_changed  (GtkComboBox     *combobox,
                                    gpointer         user_data)
{
	config.abitrate = gtk_combo_box_get_active(combobox);
}


void
on_amode_comboboxentry_changed        (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	config.amode = gtk_combo_box_get_active(combobox);
}


void
on_configClose_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
	gtk_widget_destroy(configureWindow);
}


void
on_subpos_comboboxentry_changed
                                        (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	config.subpos = gtk_combo_box_get_active(combobox);
}


void
on_subblur_comboboxentry_changed   (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	config.subblur = gtk_combo_box_get_active(combobox);
}


void
on_subOutline_comboboxentry_changed
                                        (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	config.suboutline = gtk_combo_box_get_active(combobox);
}


void
on_subsize_comboboxentry_changed   (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	config.subsize = gtk_combo_box_get_active(combobox);
}

/* 결과물 앞에 분틀 접두어 엔트리 수정시 */
void on_outfilePre_entry(GtkEntry *entry, gpointer user_data)
{
	free(work_info.prefix);
	work_info.prefix = strdup(gtk_entry_get_text(entry));
}

gboolean bus_callback(GstBus *bus, GstMessage *msg, gpointer data)
{
	switch (GST_MESSAGE_TYPE(msg)) {
		case GST_MESSAGE_ERROR:
		case GST_MESSAGE_EOS:
			gst_element_set_state(GST_ELEMENT(data), GST_STATE_READY);
			break;
		default:
			break;
	}

	return TRUE;
}

void on_playSound_checkbutton_toggled(GtkToggleButton *togglebutton,
									gpointer user_data)
{
	work_info.play_sound = gtk_toggle_button_get_active(togglebutton);
}
