/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "interface.h"
#include "support.h"
#include "mypopen.h"
#include "callbacks.h"

static void getReadyWork(void);

int
main (int argc, char *argv[])
{
  GtkWidget *gmencoder_window;
  int count;

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
                      argc, argv,
                      GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR,
                      NULL);
	gst_init(0, NULL);

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */

	config_Init();
	getReadyWork();
	
/*	filter_audio = gtk_file_filter_new();
	gtk_file_filter_set_name(filter_audio, "음악 파일");
	for (count = 0; count < G_N_ELEMENTS(audio_mime_types); count++) {
		gtk_file_filter_add_mime_type(filter_audio, audio_mime_types[count]);
	}*/

	gmencoder_window = create_gmencoder_window ();
	gtk_widget_show (gmencoder_window);
  
	/* gstreamer를 사용하여 사운드를 초기화 */
	gstSound = gst_element_factory_make("playbin", "playbin");

	if (gstSound) {
		GstBus *bus;

		g_object_set(G_OBJECT(gstSound), "video-sink", NULL, NULL);
		g_object_set(G_OBJECT(gstSound), "vis-plugin", NULL, NULL);

		bus = gst_pipeline_get_bus(GST_PIPELINE(gstSound));
		gst_bus_add_watch(bus, bus_callback, gstSound);
		gst_object_unref(bus);
	}

  gtk_main ();
  return 0;
}

/* 설정 구조체 초기화 */
void config_Init(void)
{
	config.onlyrebuild = FALSE;
	config.useSource = FALSE;
	config.useSSound = FALSE;
	config.vbitrate = 0;
	config.use_ofps = TRUE;
	config.ofps = 0;
	config.use_scale = TRUE;
	config.hscale = 320;
	config.vscale = 240;
	config.use_crop = TRUE;
	config.crop = 2;
	config.vcodec = 0;
	config.acodec = 0;
	config.abitrate = 1;
	config.vol = 0;
	config.aq = 7;
	config.amode = 1;
	config.vbr = 3;
	config.use_srate = TRUE;
	config.srate = 0;
	config.subpos = 2;
	config.subblur = 2;
	config.suboutline = 2;
	strcpy(config.subfont, "/usr/share/fonts/truetype/baekmuk/gulim.ttf");
	config.subsize = 1;
	config.use_sub = TRUE;
	config.extra = NULL;
}

/* 인코딩 환경을 저장합니다. */
void save_configure(FILE *fp)
{
	fprintf(fp, "onlyrebuild=%d\n", config.onlyrebuild);
	fprintf(fp, "useSource=%d\n", config.useSource);
	fprintf(fp, "useSSound=%d\n", config.useSSound);
	fprintf(fp, "vbitrate=%d\n", config.vbitrate);
	fprintf(fp, "use_ofps=%d\n", config.use_ofps);
	fprintf(fp, "ofps=%d\n", config.ofps);
	fprintf(fp, "use_scale=%d\n", config.use_scale);
	fprintf(fp, "hscale=%d\n", config.hscale);
	fprintf(fp, "vscale=%d\n", config.vscale);
	fprintf(fp, "use_crop=%d\n", config.use_crop);
	fprintf(fp, "crop=%d\n", config.crop);
	fprintf(fp, "vcodec=%d\n", config.vcodec);
	fprintf(fp, "acodec=%d\n", config.acodec);
	fprintf(fp, "abitrate=%d\n", config.abitrate);
	fprintf(fp, "vol=%d\n", config.vol);
	fprintf(fp, "aq=%d\n", config.aq);
	fprintf(fp, "amode=%d\n", config.amode);
	fprintf(fp, "vbr=%d\n", config.vbr);
	fprintf(fp, "use_srate=%d\n", config.use_srate);
	fprintf(fp, "srate=%d\n", config.srate);
	fprintf(fp, "subpos=%d\n", config.subpos);
	fprintf(fp, "subblur=%d\n", config.subblur);
	fprintf(fp, "suboutline=%d\n", config.suboutline);
	fprintf(fp, "subfont=%s\n", config.subfont);
	fprintf(fp, "subsize=%d\n", config.subsize);
	fprintf(fp, "use_sub=%d\n",	config.use_sub);
	fprintf(fp, "extra=%s\n\n", config.extra);
}

/* 사전 작업을 실시합니다. */
static void getReadyWork(void)
{
	FILE *fp;
	
	sprintf(miri_file, "%s%s", g_get_home_dir(), "/.gmencodersh");

	if (access(miri_file, F_OK)) {
		fp = fopen(miri_file, "w");
		fprintf(fp, "[기본설정(PDA기본)]\n");
		fprintf(fp, "기본 인코딩입니다. 일반적인 PDA용 입니다.\n");
		save_configure(fp);
		fclose(fp);
	}

	work_info.outDir = strdup(g_get_home_dir());
	work_info.prefix = strdup("[G]");
	work_info.sound = NULL;
	work_info.play_sound = FALSE;
	
	file_num = 0;
}
