#include <stdio.h>
#include <string.h>
#include <gnome.h>
#include <unistd.h>
#include <pthread.h>
#include <libgen.h>
#include <strings.h>
#include "interface.h"
#include "mypopen.h"

/* totem-video-indexer 를 이용하여 비디오 파일의 정보를 얻어 옵니다. */
void get_video_info(char *filename, gpointer user_data)
{
	FILE *po;
	char *tok;
	char cmd[256];
	char buf[256];
	char *video_info[6] = {NULL, NULL, NULL, NULL, NULL, NULL};
	GtkTreeIter iter;

	video_info[0] = (char *)malloc(sizeof(filename));
	video_info[0] = strdup(filename);
	
	sprintf(cmd, "%s \"%s\" %s", "totem-video-indexer", filename, "2>/dev/null");

	if ((po = popen(cmd, "r")) != NULL) {
		while(fgets(buf, 256, po) != NULL) {
			tok = strtok(buf, "=");

			if (!strcmp(tok, "TOTEM_INFO_VIDEO_WIDTH")) {
				tok = strtok(NULL, "=");
				tok[strlen(tok) - 1] = '\0';
				video_info[1] = strdup(tok);
			} else if (!strcmp(tok, "TOTEM_INFO_VIDEO_HEIGHT")) {
				tok = strtok(NULL, "=");
				tok[strlen(tok) - 1] = '\0';
				video_info[2] = strdup(tok);
			} else if (!strcmp(tok, "TOTEM_INFO_VIDEO_CODEC")) {
				tok = strtok(NULL, "=");
				tok[strlen(tok) - 1] = '\0';
				video_info[3] = strdup(tok);
			} else if (!strcmp(tok, "TOTEM_INFO_AUDIO_CODEC")) {
				tok = strtok(NULL, "=");
				tok[strlen(tok) - 1] = '\0';
				video_info[4] = strdup(tok);
			} else if (!strcmp(tok, "TOTEM_INFO_DURATION")) {
				tok = strtok(NULL, "=");
				tok[strlen(tok) - 1] = '\0';
				video_info[5] = strdup(tok);
			}
		}

		if (video_info[5] != NULL) {
			gtk_list_store_append(GTK_LIST_STORE(user_data), &iter);
			gtk_list_store_set(GTK_LIST_STORE(user_data), &iter,
							COL_FILENAME, filename,
							COL_WIDTH, video_info[1],
							COL_HEIGHT, video_info[2],
							COL_VCODEC, video_info[3],
							COL_ACODEC, video_info[4],
							COL_LENGTH, video_info[5],
							-1);	
		} else
			gtk_widget_show(create_gmencoder_messagebox("동영상 파일이 아닙니다."));
	}

	pclose(po);
}

extern char *vbitrate_data[];
extern char *frame_data[];
extern char *abitrate_data[];
extern char *srate_data[];
extern char *subpos_data[];
extern char *subsize_data[];
gchar *dirc, *basec;
FILE *po;

static void pthread_cleanup(void *arg)
{
	GtkTextIter end;

	gtk_text_buffer_get_end_iter(working_buffer, &end);
	gtk_text_buffer_insert(working_buffer, &end, "\n작업중지\n\n", -1);
	
	free(dirc);
	free(basec);
	pclose(po);

	gtk_widget_destroy(workState_dialog);
}

/* mencoder를 실행합니다. */
void play_mencoder(gpointer user_data)
{
	gint count;
	struct tm *ptr_t;
	time_t start_t, finsh_t, dif_t;
	gchar buf[256], *sf, *dname, *bname, *ext, of[256];
	GtkTextIter end;
	GtkTreeIter iter;
	GtkWidget *progressbar;
	gchar fileCount[10];
	gdouble progress;
	
	pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, NULL);
	pthread_cleanup_push(pthread_cleanup, (void*)NULL);

	sleep(1);

	time(&start_t);
	
	progressbar = g_object_get_data(G_OBJECT(workState_dialog), "progressbar");

	gtk_tree_model_get_iter_first(GTK_TREE_MODEL(user_data), &iter);

	for (count = 0; count < file_num; count++) {
		gtk_tree_model_get(GTK_TREE_MODEL(user_data), &iter, COL_FILENAME, &sf, -1);

		sprintf(working, "%s \"%s\"\n", "작업시작:", sf);
		gtk_text_buffer_get_end_iter(working_buffer, &end);
		gtk_text_buffer_insert_with_tags_by_name(working_buffer, &end, working, -1, "bold", NULL);
		
		dirc = strdup(sf);
		basec = strdup(sf);
		dname = dirname(dirc);
		bname = basename(basec);
		sprintf(working, "mencoder \"%s\" -o \"%s/%s%s\"", sf, dname, work_info.prefix, bname);

		if (config.onlyrebuild) {
				strcat(working, " -ovc copy -oac copy");
		} else {
			strcat(working, " -mc 0");

			if (!config.useSource) {
				sprintf(buf, " -lavcopts vbitrate=%s", vbitrate_data[config.vbitrate]);
				strcat(working, buf);

				if (config.use_ofps) {
					sprintf(buf, " -ofps %s", frame_data[config.ofps]);
					strcat(working, buf);
				}

				if (config.use_scale) {
					sprintf(buf, " -vf-add scale=%d:%d",config.hscale, config.vscale);
					strcat(working, buf);
				}

				switch (config.vcodec) {
					case 0:	strcat(working, " -ovc lavc -lavcopts vcodec=mpeg4 -ffourcc DIVX");
							break;
					case 1: strcat(working, " -ovc xvid -xvidencopts");
							break;
					case 2: strcat(working, " -ovc lavc -lavcopts vcodec=msmpeg4 -ffourcc DIV3");
							break;
					case 3: strcat(working, " -ovc lavc -lavcopts vcodec=msmpeg4 -ffourcc MP43");
							break;
					case 4: strcat(working, " -ovc lavc -lavcopts vcodec=wmv1");
							break;
					case 5: strcat(working, " -ovc lavc -lavcopts vcodec=wmv2");
							break;
					case 6: strcat(working, " -ovc x264 -x264encopts");
							break;
				}
			} else if (config.useSource) {
				strcat(working, " -ovc copy");					
			}

			if (!config.useSSound) {
				switch (config.acodec) {
					case 0:	strcat(working, " -oac mp3lame");
							break;
					case 1:	sprintf(buf, " -oac lavc -lavcopts acodec=ac3:abitrate=%s -channels 2", abitrate_data[config.abitrate]);
							strcat(working, buf);
							break;
					case 2:	sprintf(buf, " -oac lavc -lavcopts acodec=mp2:abitrate=%s -channels 2", abitrate_data[config.abitrate]);
							strcat(working, " -oac lavc -lavcopts acodec=mp2:abitrate=64 -channels 2");
							break;
				}

				if (!config.acodec) {
					sprintf(buf, " -lameopts br=%s", abitrate_data[config.abitrate]);
					strcat(working, buf);

					sprintf(buf, " -lameopts vol=%d", config.vol);
					strcat(working, buf);

					sprintf(buf, " -lameopts aq=%d", config.aq);
					strcat(working, buf);

					sprintf(buf, " -lameopts mode=%d", config.amode);
					strcat(working, buf);

					sprintf(buf, " -lameopts vbr=%d", config.vbr);
					strcat(working, buf);

					if (config.use_srate) {
						sprintf(buf, " -srate %s", srate_data[config.srate]);
						strcat(working, buf);
					}
				}
			} else if (config.useSSound) {
				strcat(working, " -oac copy");
			}
		}

		if (config.use_sub && !config.onlyrebuild && !config.useSource) {
			if (strstr(bname, ".") != NULL) {
				ext = rindex(bname, '.');
				*ext = '\0';
			}
			sprintf(buf, "%s/%s%s", dname, bname, ".smi");

			if (!access(buf, F_OK)) {
				sprintf(buf, " -font \"%s\"", config.subfont);
				strcat(working, buf);

				sprintf(buf, " -sub \"%s/%s.%s\"", dname, bname, "smi");
				strcat(working, buf);

				strcat(working, " -utf8");

				sprintf(buf, " -subpos %s", subpos_data[config.subpos]);
				strcat(working, buf);

				sprintf(buf, " -subfont-text-scale %s", subsize_data[config.subsize]);
				strcat(working, buf);

				sprintf(buf, " -subfont-blur %d", config.subblur);
				strcat(working, buf);

				sprintf(buf, " -subfont-outline %d", config.suboutline);
				strcat(working, buf);
			}
		}

		gtk_text_buffer_get_end_iter(working_buffer, &end);
		gtk_text_buffer_insert(working_buffer, &end, working, -1);
	
		sprintf(fileCount, "(%d/%d)", count+1, file_num);
		gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progressbar), fileCount);
	
		if ((po = popen(working, "r"))) {
			while(fgets(buf, 255, po)) {
			puts(buf);
			}
		}
		pclose(po);

		sprintf(buf, "\n작업완료 (%d/%d)\n", count+1, file_num);

		gtk_text_buffer_get_end_iter(working_buffer, &end);
		gtk_text_buffer_insert(working_buffer, &end, buf, -1);

		free(dirc);
		free(basec);

		gtk_tree_model_iter_next(GTK_TREE_MODEL(user_data), &iter);
	}

	time(&finsh_t);
	dif_t = difftime(finsh_t, start_t);
	ptr_t = gmtime(&dif_t);
	strftime(buf, 255, "전체 작업완료 (걸린 시간: %H:%M:%S)\n\n", ptr_t);

	gtk_text_buffer_get_end_iter(working_buffer, &end);
	gtk_text_buffer_insert_with_tags_by_name(working_buffer, &end, buf, -1, "underline", NULL);
	
	gtk_widget_destroy(workState_dialog);

	pthread_cleanup_pop(0);
}
